﻿using Syncfusion.UI.Xaml.Grid;
using System;
using System.Windows.Input;

namespace Test
{

    public static class Commands
    {

        static Commands()
        {

            CommandManager.RegisterClassCommandBinding(typeof(SfDataGrid), new CommandBinding(PrintPreview, OnPrintGrid));
            CommandManager.RegisterClassCommandBinding(typeof(SfDataGrid), new CommandBinding(DirectPrint, OnDirectPrintGrid));

        }

        #region Print Preview Command

        public static RoutedCommand PrintPreview = new RoutedCommand("PrintPreview", typeof(SfDataGrid));

        private static void OnPrintGrid(object sender, ExecutedRoutedEventArgs args)
        {

            var dataGrid = args.Source as SfDataGrid;
            if (dataGrid == null) return;

            try
            {

                dataGrid.PrintSettings.PrintScaleOption = Syncfusion.UI.Xaml.Grid.PrintScaleOptions.FitViewonOnePage;
                dataGrid.PrintSettings.AllowColumnWidthFitToPrintPage = false;
                dataGrid.PrintSettings.AllowRepeatHeaders = true;
                dataGrid.ShowPrintPreview();

            }
            catch (Exception)
            {

            }

        }

        #endregion

        #region Print Command

        public static RoutedCommand DirectPrint = new RoutedCommand("DirectPrint", typeof(SfDataGrid));

        private static void OnDirectPrintGrid(object sender, ExecutedRoutedEventArgs args)
        {

            var dataGrid = args.Source as SfDataGrid;
            if (dataGrid == null) return;

            try
            {

                dataGrid.Print();

            }
            catch (Exception)
            {

            }

        }

        #endregion
    }

}
