﻿using Syncfusion.Data;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Windows;
using System.Windows.Data;

namespace Test.Views
{

    public partial class MainWindow : Window
    {

        private List<TableData> SourceData;
        public List<TableData_1> TD1;
        public List<TableData_2> TD2;

        public MainWindow()
        {

            InitializeComponent();

            this.SourceData = this.GenSourceData();

            this.TD1 = new List<TableData_1>();
            this.TD2 = new List<TableData_2>();

            //--generate tables with diferent columns adn data
            foreach (TableData T in this.SourceData)
            {

                this.TD1.Add(new TableData_1(T));
                this.TD2.Add(new TableData_2(T));
               
            }

            //--add reference to tables
            foreach(TableData_1 T1 in TD1)
            {

                foreach (TableData_2 T2 in TD2)
                {

                    if ((T2.Date.Year == T2.Date.Year) && (T1.Date.Month == T2.Date.Month) && (T1.Date.Day == T2.Date.Day))
                    {
                        T1.SetTD2(T2);
                        T2.SetTD1(T1);
                        break;

                    }

                }

            }

            this.grid1.ItemsSource = this.TD1;
            this.grid2.ItemsSource = this.TD2;

        }

        /*
        private void LoadData(object sender, RoutedEventArgs e)
        {

            Random rnd = new Random();

        }
        */

        private List<TableData> GenSourceData()
        {

            List<TableData> Ret = new List<TableData>();

            Random rnd = new Random();

            DateTime FirstDate = new DateTime(2017, 2, 1);

            for (var i = 0; i < 99; i++)
            {

                FirstDate = FirstDate.AddDays(1);

                Ret.Add(new TableData() { Date = FirstDate, Data = this.GenRandomDict(rnd) });

            }

            return Ret;

        }

        private Dictionary<string, object> GenRandomDict(Random rnd)
        {
            
            Dictionary<string, object> Dict = new Dictionary<string, object>();

            this.GenRandomDict__fromType(ref Dict, typeof(TableData_1), rnd);
            this.GenRandomDict__fromType(ref Dict, typeof(TableData_2), rnd);

            return Dict;

        }

        private void GenRandomDict__fromType(ref Dictionary<string, object> Dict, Type T, Random rnd)
        {

            PropertyInfo[] PI = T.GetProperties(BindingFlags.Instance | BindingFlags.Public);

            foreach (PropertyInfo P in PI)
            {

                Dict.Add(T.Name + "-" + P.Name, (double?) rnd.Next(0, 999999));

            }

        }        

    }

    public class CustomAggregate : ISummaryAggregate
    {

        public string Date_Text_Sum { get; set; }
        public string Date_Text_Avg { get; set; }

        Action<IEnumerable, string, PropertyDescriptor> ISummaryAggregate.CalculateAggregateFunc()
        {

            return (items, property, pd) =>
            {

                if (pd.Name == "Date_Text_Sum") this.Date_Text_Sum = "Sum";
                else if (pd.Name == "Date_Text_Avg") this.Date_Text_Avg = "Average";

            };

        }

    }

    public class TableData_1 : TableData
    {
        Dictionary<string, string[]> ProperyMapping = new Dictionary<string, string[]>()
        {
            { "A", new string[] {"C"} },
            { "B", new string[] {"C"} }
        };

        Dictionary<string, string[]> DependentMapping = new Dictionary<string, string[]>()
        {
            { "A", new string[] { "GA" } },
            { "B", new string[] { "GB" } }
        };

        private TableData_2 TD2 { get; set; }

        public void SetTD2(TableData_2 TD2)
        {
            this.TD2 = TD2;
        }

        public double? A { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? B { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? C { get { return this.A + this.B; } }                                                                                                    
        public double? D { get { return this.TD2?.GD; } }
        public double? E { get { return this.TD2?.GE; } }
        public double? F { get { return this.TD2?.GD + this.TD2?.GE; } }
        public double? G { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? H { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? I { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? J { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? K { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? L { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? M { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? N { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? O { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? P { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? Q { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? R { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? S { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? T { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? U { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? V { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? W { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? X { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? Y { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? Z { get { return (double?) base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }

        public override void UpdateProperties([CallerMemberName] string propertyName = null)
        {
            base.UpdateProperties(propertyName);
            if(ProperyMapping.ContainsKey(propertyName))
            {
                foreach (var dependentPropertyName in ProperyMapping[propertyName])
                {
                    OnPropertyChanged(dependentPropertyName);
                }
            }
            if (DependentMapping.ContainsKey(propertyName))
            {
                foreach (var dependentPropertyName in DependentMapping[propertyName])
                {
                    this.TD2.OnPropertyChanged(dependentPropertyName);
                }
            }
        }
        //public override void UpdateProperties(params int[] Called)
        //{

        //    //--for update from other class
        //    base.UpdateProperties(Called);

        //    //--update other class values
        //    if (this.CallCheck(this.TD2, this.GetHashCode(), Called)) this.TD2?.UpdateProperties(Called.AddValueAtEnd(this.GetHashCode()));

        //}

        public TableData_1(TableData Source)
        {

            this.Date = Source.Date;
            this.Data = Source.Data;

        }

    }

    public class TableData_2 : TableData
    {
        Dictionary<string, string[]> ProperyMapping = new Dictionary<string, string[]>()
        {
            { "GA", new string[] {"GC"} },
            { "GB", new string[] {"GC"} }
        };

        Dictionary<string, string[]> DependentMapping = new Dictionary<string, string[]>()
        {
            { "GD", new string[] { "D" } },
            { "GE", new string[] { "E" } }
        };
        private TableData_1 TD1 { get; set; }

        public void SetTD1(TableData_1 TD1)
        {
            this.TD1 = TD1;
        }

        public double? GA { get { return TD1?.A; } }
        public double? GB { get { return TD1?.B; } }
        public double? GC { get { return this.GA / this.GB; } }
        public double? GD { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GE { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GF { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GG { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GH { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GI { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GJ { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GK { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GL { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GM { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GN { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GO { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GP { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GQ { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GR { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GS { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GT { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GU { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GV { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GW { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GX { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GY { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }
        public double? GZ { get { return (double?)base[this.Nam(MethodBase.GetCurrentMethod())]; } set { base[this.Nam(MethodBase.GetCurrentMethod())] = value; UpdateProperties(); } }

        public override void UpdateProperties([CallerMemberName] string propertyName = null)
        {
            base.UpdateProperties(propertyName);
            if (ProperyMapping.ContainsKey(propertyName))
            {
                foreach (var dependentPropertyName in ProperyMapping[propertyName])
                {
                    OnPropertyChanged(dependentPropertyName);
                }
            }
            if (DependentMapping.ContainsKey(propertyName))
            {
                foreach (var dependentPropertyName in DependentMapping[propertyName])
                {
                    this.TD1.OnPropertyChanged(dependentPropertyName);
                }
            }
        }
        //public override void UpdateProperties(params int[] Called)
        //{

        //    //--for update from other class
        //    base.UpdateProperties(Called);

        //    //--update other class values
        //    if (this.CallCheck(this.TD1, this.GetHashCode(), Called)) this.TD1?.UpdateProperties(Called.AddValueAtEnd(this.GetHashCode()));

        //}

        public TableData_2(TableData Source)
        {

            this.Date = Source.Date;
            this.Data = Source.Data;

        }

    }

    public class TableData : INotifyPropertyChanged, INotifyPropertyChanging
    {

        public DateTime Date { get; set; }

        public string XX { get { return null; } }

        public Dictionary<string, object> Data { get; set; }  //--Dictionary with values from database (for all tables in one dictionary)

        public string Nam(MethodBase Method)
        {

            //--property with name like TableData_1-A, TableData_2-B, ...
            return this.GetType().Name + "-" + Method.Name.Replace("get_", "").Replace("set_", "");

        }

        #region  INotify

        protected virtual event PropertyChangedEventHandler PropertyChanged;
        event PropertyChangedEventHandler INotifyPropertyChanged.PropertyChanged
        {
            add { PropertyChanged += value; }
            remove { PropertyChanged -= value; }
        }

        protected virtual event PropertyChangingEventHandler PropertyChanging;

        event PropertyChangingEventHandler INotifyPropertyChanging.PropertyChanging
        {
            add { PropertyChanging += value; }
            remove { PropertyChanging -= value; }
        }

        protected internal virtual void OnPropertyChanged(string name)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(name));
        }

        protected internal virtual void OnPropertyChanging(string name)
        {
            PropertyChanging?.Invoke(this, new PropertyChangingEventArgs(name));
        }

        #endregion

        public object this[string key]
        {
            get
            {

                return this.Data?[key];

            }
            set
            {

                //OnPropertyChanging(Binding.IndexerName);
                this.Data[key] = value;
                //OnPropertyChanged(Binding.IndexerName);

            }
        }

        public bool CallCheck(object Call, int Hash, int[] Called)
        {
            //--prevent from loop
            return !((Call == null) || (Array.IndexOf(Called, Hash) != -1));
        }

        public virtual void UpdateProperties([CallerMemberName] string propertyName = null)
        {
            OnPropertyChanged(propertyName?? string.Empty);
        }
        //public virtual void UpdateProperties(params int[] Called)
        //{
        //    OnPropertyChanged(Binding.IndexerName);
        //}

    }

    public static class Helpers
    {

        public static int[] AddValueAtEnd(this int[] Array, int Value)
        {

            int[] Output = new int[Array.Length + 1];

            for (int i = 0; i < Array.Length; i++) Output[i] = Array[i];

            Output[Output.Length - 1] = Value;

            return Output;

        }

    }

}
