﻿using System.Collections.Generic;
using System.ComponentModel;

namespace Test.Views
{
    public class MainWindowViewModel : INotifyPropertyChanged
    {

        public event PropertyChangedEventHandler PropertyChanged;


        public void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null) PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        private List<Customer> _customers;

        public List<Customer> Customers
        {
            get { return _customers; }
            set {

                if (value != _customers)
                {
                    _customers = value;
                    OnPropertyChanged("Customers");
                }
            }
        }

        private List<Customer> _customers2;

        public List<Customer> Customers2
        {
            get { return _customers2; }
            set
            {

                if (value != _customers2)
                {
                    _customers2 = value;
                    OnPropertyChanged("Customers2");
                }
            }
        }

        //public RelayCommand LoadCommand { get; private set; }

        public MainWindowViewModel()
        {
           
            //LoadCommand = new RelayCommand(() => Load());

            Customers = new List<Customer>();

            for (int i = 1; i <= 20; i++)
            {

                Customers.Add
                (
                    new Customer { CustomerId = i, FirstName = "Column 1 + " + i, LastName = "Column 2 + " + i, A = 5 + i, B = 10 + i }
                );

            }

            Customers2 = new List<Customer>();

            for (int i = 21; i <= 40; i++)
            {

                Customers2.Add
                (
                    new Customer { CustomerId = i, FirstName = "Column 1 + " + i, LastName = "Column 2 + " + i, A = 5 + i, B = 10 + i }
                );

            }

        }        

    }

    public class Customer
    {

        public int CustomerId { get; set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }

        public int A { get; set; }
        public int B { get; set; }
        public int C { get { return A + B; } }

    }

}
